---
Name: proxmox-lab-network
Description: Set up the lab network.
Documentation: |
  Set up the proxmox based lab network enviornment for the target
  VMs systems.

  NOTE that the "interfaces.d" directory is not supported out-of-the-box with
  Proxmox.  The "SDN" perl package must be installed for it to be supported.
  However, the VMs will work with this method, but the networks are not
  manageable in the Proxmox Web Portal.

Meta:
  color: blue
  feature-flags: sane-exit-codes
  icon: shopping cart
  title: RackN Content
OptionalParams: []
Prerequisites: []
RequiredParams:
  - "proxmox/lab-student-count"
Templates:
  - Name: "proxmox-lab-network"
    Contents: |-
      #!/usr/bin/env bash
      # Proxmox Lab Networking setup

      {{ template "prelude.tmpl" . }}

      TAG={{ .Param "proxmox/lab-base-tag" }}
      BASE="br-${TAG}-"

      if [[ ! -d /etc/network ]]
      then
        echo "FATAL: '/etc/network' directory does not exist"
        exit 1
      fi

      if ! grep -q "^source /etc/network/interfaces.d" /etc/network/interfaces
      then
        mkdir -p /etc/network/interfaces.d
        echo "source /etc/network/interfaces.d/*" >> /etc/network/interfaces
      fi

      COUNT={{ .Param "proxmox/lab-student-count" }}

      echo "Destroying any potential pre-existing '${BASE}*' bridge interfaces..."
      rm -f /etc/network/interfaces.d/${BASE}*

      for NUM in $(seq $COUNT)
      do
        BR_FILE="/etc/network/interfaces.d/${BASE}${NUM}"
        BRIDGE=${BASE}${NUM}
        cat <<EOF > ${BR_FILE}
      # setup isolated bridge ${NUM}
      auto ${BRIDGE}
        iface ${BRIDGE} inet manual
        pre-up brctl addbr ${BRIDGE}
        post-up ip link set ${BRIDGE} up
        pre-down ip link set ${BRIDGE} down
        post-down brctl delbr ${BRIDGE}

      EOF

        if [[ -f ${BR_FILE} ]]
        then
          echo "----------------------------------------------------------------------------------"
          echo "Bridge interface config for '${BR_FILE}':"
          cat ${BR_FILE}
          echo "----------------------------------------------------------------------------------"
          echo "Attempting to start up bridge '$BRIDGE'..."
          ifup ${BRIDGE}
          echo "----------------------------------------------------------------------------------"
          echo "Running bridge configuration for '$BRIDGE'..."
          ip a sh ${BRIDGE}
          echo "----------------------------------------------------------------------------------"
        else
          echo ">>> FATAL: bridge file doesn't exist, create failed (for '$BR_FILE')"
          exit 1
        fi
      done

      echo "Remove the Enterprise APT repository if it exists"
      ENT="/etc/apt/sources.list.d/pve-enterprise.list"
      [[ -r "$ENT" ]] && rm -f "$ENT"

      echo "Install 'lldpd' package"
      install lldpd

